#ifndef RLYSON_HPP
#define RLYSON_HPP

#ifdef __cplusplus
extern "C" {
#endif


#include <raylib.h>


/*
	the following functions are not part of the raylib API, 
	but are used by alyson and can be used by other projects using alyson
*/

typedef enum {
	TEXT_ORIENTATION_LEFT,
	TEXT_ORIENTATION_RIGHT,
	TEXT_ORIENTATION_CENTER
} text_orientation_t;

void DrawTextFull(
	Font                font,
	const char*         text,
	Vector2             origin,
	text_orientation_t  orientation,
	float               rotation,
	float               fontSize,
	float               spacing,
	float               lineSpacing,
	Color               tint
);

#ifndef RLAYSON_NO_ANIMATION
#include <animation/sprite.h>
// other animation types
#endif



#ifdef __cplusplus
}
#endif


#endif // RLYSON_HPP